/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VWebApplicationSessionstateRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VWebApplicationSessionstate extends TableImpl<VWebApplicationSessionstateRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_web_application_sessionstate</code>
     */
    public static final VWebApplicationSessionstate V_WEB_APPLICATION_SESSIONSTATE = new VWebApplicationSessionstate();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VWebApplicationSessionstateRecord> getRecordType() {
        return VWebApplicationSessionstateRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_web_application_sessionstate.application_id</code>.
     */
    public final TableField<VWebApplicationSessionstateRecord, Integer> APPLICATION_ID = createField(DSL.name("application_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_web_application_sessionstate.application_name</code>.
     */
    public final TableField<VWebApplicationSessionstateRecord, String> APPLICATION_NAME = createField(DSL.name("application_name"), SQLDataType.CLOB, this, "");

    /**
     * The column
     * <code>common_dd.v_web_application_sessionstate.fk_person_usnr</code>.
     */
    public final TableField<VWebApplicationSessionstateRecord, Integer> FK_PERSON_USNR = createField(DSL.name("fk_person_usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_web_application_sessionstate.key</code>.
     */
    public final TableField<VWebApplicationSessionstateRecord, String> KEY = createField(DSL.name("key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_web_application_sessionstate.value</code>.
     */
    public final TableField<VWebApplicationSessionstateRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VWebApplicationSessionstate(Name alias, Table<VWebApplicationSessionstateRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VWebApplicationSessionstate(Name alias, Table<VWebApplicationSessionstateRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_web_application_sessionstate" as  SELECT t_web_application.pk AS application_id,
         t_web_application.name AS application_name,
         t_web_sessionstate.fk_usnr AS fk_person_usnr,
         t_web_sessionstate.key,
         t_web_sessionstate.value
        FROM (common_dd.t_web_application
          RIGHT JOIN common_dd.t_web_sessionstate ON ((t_web_sessionstate.fk_application = t_web_application.pk)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_web_application_sessionstate</code>
     * table reference
     */
    public VWebApplicationSessionstate(String alias) {
        this(DSL.name(alias), V_WEB_APPLICATION_SESSIONSTATE);
    }

    /**
     * Create an aliased <code>common_dd.v_web_application_sessionstate</code>
     * table reference
     */
    public VWebApplicationSessionstate(Name alias) {
        this(alias, V_WEB_APPLICATION_SESSIONSTATE);
    }

    /**
     * Create a <code>common_dd.v_web_application_sessionstate</code> table
     * reference
     */
    public VWebApplicationSessionstate() {
        this(DSL.name("v_web_application_sessionstate"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VWebApplicationSessionstate as(String alias) {
        return new VWebApplicationSessionstate(DSL.name(alias), this);
    }

    @Override
    public VWebApplicationSessionstate as(Name alias) {
        return new VWebApplicationSessionstate(alias, this);
    }

    @Override
    public VWebApplicationSessionstate as(Table<?> alias) {
        return new VWebApplicationSessionstate(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VWebApplicationSessionstate rename(String name) {
        return new VWebApplicationSessionstate(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VWebApplicationSessionstate rename(Name name) {
        return new VWebApplicationSessionstate(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VWebApplicationSessionstate rename(Table<?> name) {
        return new VWebApplicationSessionstate(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate where(Condition condition) {
        return new VWebApplicationSessionstate(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VWebApplicationSessionstate where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VWebApplicationSessionstate where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VWebApplicationSessionstate where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VWebApplicationSessionstate where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VWebApplicationSessionstate whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
